#include <qpainter.h>
#include <qmenubar.h>
#include <qapplication.h>
#include <qmessagebox.h>

#include "app_window.h"
#include "board.h"

#define str(s) xstr(s)
#define xstr(s) #s
#define appName zMerlin

AppWindow::AppWindow( QWidget* parent, const char* name, WFlags f )
	: QMainWindow( parent, name, f )
{
	setCaption(str(appName));
	srand(time(NULL));

	board = new Board(this);
	board->setGeometry(8, 35, 225, 225);

	QMenuBar *mb=menuBar();

    appMenu = new QPopupMenu;
	appMenu->insertItem( "&About", ABOUT);
	appMenu->insertItem( "&Rules", RULES);
	appMenu->insertSeparator();
	appMenu->insertItem( "&Exit", EXIT);
	mb->insertItem(str(&appName), appMenu);
	connect( appMenu, SIGNAL(activated(int)),SLOT(menuSelected(int))); 
    levelMenu = new QPopupMenu;
/*	levelMenu->insertItem( "&Restart", RESTART_LEVEL);
	levelMenu->insertItem( "&New random Level", NEW_RAND_LEVEL);
	levelMenu->insertSeparator();
	levelMenu->insertItem( "&Level 1", LEVELNUM+0);
	levelMenu->insertItem( "&Level 2", LEVELNUM+1);
	levelMenu->insertItem( "&Level 3", LEVELNUM+2);
	levelMenu->insertItem( "&Level 4", LEVELNUM+3);
	levelMenu->insertItem( "&Level 5", LEVELNUM+4);
	levelMenu->insertItem( "&Level 6", LEVELNUM+5);
	levelMenu->insertItem( "&Level 7", LEVELNUM+6);
	levelMenu->insertItem( "&Level 8", LEVELNUM+7);
	levelMenu->insertItem( "&Level 9", LEVELNUM+8);
	levelMenu->insertItem( "&Level 10", LEVELNUM+9);
	mb->insertItem("&Level", levelMenu);
*/	connect( levelMenu, SIGNAL(activated(int)),SLOT(menuSelected(int))); 
}

void AppWindow::paintEvent ( QPaintEvent * )
{
	QPixmap tpix(width(),height());
	tpix.fill(QColor(199,190,166));
	
	QPainter p(this);
	p.drawPixmap(0,0,tpix);
	
}


void AppWindow::menuSelected(int id)
{
	int levelNum = -1;

	switch(id)
 {
		case EXIT:
			close();
		break;
		case ABOUT:
			QMessageBox *abox;
			abox = new QMessageBox(this, "About");
			abox->setText("<center><B>zMerlin</B><BR>www.linux-games.com<BR><BR>(c) 2002 by Karl Bartel<BR>This is free Software (GPL)</center>");
			abox->show();
		break;
		case RULES:
			QMessageBox *rbox;
			rbox = new QMessageBox(this, "Rules");
			rbox->setText("<center><B>zMerlin Rules</B></center><BR><b>Goal:</b> Fill the 3*3 matrix with cute penguins!<BR><b>But how?</b> When you tap on one block, the block itself and some adjacent blocks will be inverted (if there's a penguin it will be removed, if not a penguin will be placed).");
			rbox->setMaximumWidth(210);
			rbox->show();
		break;
		case LEVELNUM:
			levelNum = 0;
		break;
		default:
		break;
	}
}
